#!/bin/csh
#unlimit
limit coredumpsize 0
set working_directory = `grep working_directory mparameters_run | awk '{print $2}'`
cd ${working_directory}
#
set start = $3
set radius      = `grep radius mparameters_run | awk '{print $2}'`
set target      = `grep thresh_refine mparameters_run | awk '{print $2}'`
set pbc         = `grep PBC mparameters_run | awk '{print $2}'`
set boff        = `grep BOFF mparameters_run | awk '{print $2}'`
set dang        = `grep DANG mparameters_run | awk '{print $2}'`
set itmax       = `grep ITMAX mparameters_run | awk '{print $2}'`
set mode        = `grep MODE mparameters_run | awk '{print $2}'`
set fpart       = `grep fpart mparameters_run | awk '{print $2}'`
set rrec        = `grep res_reconstruction mparameters_run | awk '{print $2}'`
set rref        = `grep res_refinement mparameters_run | awk '{print $2}'`
set data_input  = `grep data_input mparameters_run | awk '{print $2}'`
set raw_images  = `grep raw_images mparameters_run | awk '{print $2}'`
set rbf		= `grep RBfactor mparameters_run | awk '{print $2}'`
set sym		= `grep Sym mparameters_run | awk '{print $2}'`
set pix		= `grep pix_size mparameters_run | awk '{print $2}'`
set kV		= `grep kV mparameters_run | awk '{print $2}'`
set AmpC	= `grep Amp_contrast mparameters_run | awk '{print $2}'`
set mask	= `grep mask mparameters_run | awk '{print $2}'`
set dstep	= `grep dstep mparameters_run | awk '{print $2}'`
#
set SCRATCH = ${working_directory}/scratch

@ prev = $start - 1
cd $SCRATCH
#
\rm ${data_input}_${start}_r${4}.par_${1}_${2} >& /dev/null
#
time /gusr/niko/cluster/frealign_v9.02/bin/save/frealign_v9.exe << eot >& ${data_input}_mult_refine_n_r${4}.log_${1}_${2}
M,${mode},F,F,F,${fpart},0,F,F,F,0,F,4                  !CFORM,IFLAG,FMAG,FDEF,FASTIG,FPART,IEWALD,FBEAUT,FCREF,FMATCH,IFSC,FSTAT,IBLOW
${radius},0.0,${pix},${AmpC},${mask},${pbc},${boff},${dang},${itmax},10	!RO,RI,PSIZE,WGH,XSTD,PBC,BOFF,DANG,ITMAX,IPMAX
1 1 1 1 1						!MASK
${1},${2}						!IFIRST,ILAST
${sym}							!ASYM symmetry card (I=icosahedral)
1.0,${dstep},${target},90.0,2.0,${kV},0.0,0.0		!RELMAG,DSTEP,TARGET,THRESH,CS,AKV,TX,TY
${rrec}, 200.0, ${rref}, 100.0, ${rbf}			!RREC,RMAX1,RMAX2,RBFACT
${working_directory}/${raw_images}.mrc
${data_input}_reproject_r${4}.mrc_${1}_${2}
${working_directory}/${data_input}_${prev}_r${4}.par
${data_input}_${start}_r${4}.par_${1}_${2}
${data_input}_${start}_r${4}.shft_${1}_${2}
-100., 0., 0., 0., 0., 0., 0., 0.			! terminator with RELMAG=0.0
${working_directory}/${data_input}_${prev}_r${4}.mrc
${data_input}_${start}_r${4}_weights
${data_input}_${start}_r${4}_map1.mrc
${data_input}_${start}_r${4}_map2.mrc
${data_input}_${start}_r${4}_phasediffs
${data_input}_${start}_r${4}_pointspread
eot
#
echo Job on $HOST finished >> $SCRATCH/stderr
#
