C*
C* Copyright 2013 Howard Hughes Medical Institute.
C* All rights reserved.
C* Use is subject to Janelia Farm Research Campus Software Copyright 1.1
C* license terms ( http://license.janelia.org/license/jfrc_copyright_1_1.html )
C*
C**************************************************************************
        SUBROUTINE CARD10(NANG,IFLAG,FINPAR,NNPART,ILIST,PSI,THETA,
     +                 PHI,SHX,SHY,FILM,DFMID1,DFMID2,ANGAST,OCC,
     +                 PRESA,AMEANPHAS,NPHAS,NSAM,AMAGP,NSET,PSIZE,
     +		       MAXSET,RELMAG,NSS,IFIRST,ILAST,NNSET,NSETST,
     +                 DSTEP,TNSET,FSCT,THRESH,CMIN,CMAX,XM,YM,SX,SY,
     +                 QM,NPB,ALGP,SIG)
C**************************************************************************
C Read input card 10 
C   - at least one of the following is required
C  Card 10a     FINPAR - INPUT PARAMETER FILE, required if mode key=0,1,2,3,4
C  Card 10b     NIN,ABSMAGPIN,IFILMIN,DFMID1IN,DFMID2IN,ANGASTIN,MORE if mode<0
C                 number of particles, magnification, film number, defocus
C                 parameters for this dataset.  If MORE='1', then more cards
C                 of this type follow, until MORE=0 terminates the parameter
C                 data.  The information on these cards is used to create a
C                 new parameter file.
C Called by Frealign.
C*************************************************************************
        IMPLICIT NONE
        REAL PI
	PARAMETER  (PI=3.1415926535897)
      	INTEGER NANG,NANG1,NANG2,IFLAG,NNPART,MAXSET
        INTEGER ABSMAGP,ABSMAGPIN
        INTEGER FILM(*),ILIST(*),TNSET(*),I,NPB,INPB,SLEN2
        INTEGER NNSET(*),NSAM,NSET,NPHAS,NIN,J,JN,IFIRST
        INTEGER NSS,NFILMS,NSETST,ILAST,IMORE,IFILMIN,LGP
        REAL PSIZE,DFMID1IN,DFMID2IN,ANGASTIN,ABSMAGO
        REAL PSI(*),THETA(*),PHI(*),DFMID1(*),FSCT(*)
        REAL DFMID2(*),ANGAST(*),SHX(*),SHY(*),THRESH(*)
        REAL PRESA(*),AMAGP(*),OCC(*),PXS,SIGN,SIG(*)
        REAL DSTEP(*),RELMAG(*),AMEANPHAS,PSX,ALGP(*)
        REAL CMIN(*),CMAX(*),XM(*),YM(*),SX(*),SY(*),QM(*)
	CHARACTER*200 FINPAR
	CHARACTER*200 LINE
        LOGICAL FOLD
C*************************************************************************
        IF (NANG.GE.NNPART) THEN
          IF(IFLAG.GE.0) THEN
            WRITE(*,*)' INPUT PARAMETER FILE ?'
            READ(*,7006)FINPAR
            WRITE(*,17006)FINPAR
          ELSE
7023        CONTINUE
            READ(*,*)NIN,ABSMAGPIN,IFILMIN,
     .               DFMID1IN,DFMID2IN,ANGASTIN,IMORE
            IF (IMORE.EQ.1) GOTO 7023
          ENDIF
        ELSE
C
        FOLD=.FALSE.
	NANG1=NANG
        IF (NANG.EQ.0) INPB=0
      	NFILMS=0
        CMAX(NSET)=0.0
        TNSET(NSET)=0
        XM(NSET)=0.0
        YM(NSET)=0.0
        SX(NSET)=0.0
        SY(NSET)=0.0
        QM(NSET)=0.0
        SIGN=0.0
      	IF(IFLAG.GE.0) THEN		
C				! needs input parameter file
                CMIN(NSET)=999.0
      		WRITE(*,*)' INPUT PARAMETER FILE ?'
      		READ(*,7006)FINPAR
      		WRITE(*,17006)FINPAR(1:SLEN2(FINPAR))
7006		FORMAT(A200)
17006		FORMAT(3X,A)
                OPEN(77,FILE=FINPAR,STATUS='OLD')
7009    	CONTINUE
      		READ(77,7007,END=7008)LINE
7007		FORMAT(A200)
                IF (LINE(1:1).EQ.'C') THEN
C                  IF (((INDEX(LINE,'PRES').NE.0).AND.
C     +               (INDEX(LINE,'DPRES').NE.0)).OR.
C     +               (INDEX(LINE,'Phase res. / B factor').NE.0).OR.
C     +               (INDEX(LINE,'Phase residual target').NE.0).OR.
C     +               (INDEX(LINE,'Phase residual threshold').NE.0))
C     +            THEN
C                    IF (.NOT.FOLD) WRITE(*,*) 'Old par file. ',
C     +                         'Trying pre v9 par file format...'
C                    FOLD=.TRUE.
C                  ENDIF
                  GOTO 7009
                ELSEIF (.NOT.FOLD) THEN
                  IF (LEN_TRIM(LINE).LT.120) THEN
                    WRITE(*,*) 'Old par file. ',
     +                         'Trying pre v9 par file format...'
                    FOLD=.TRUE.
                  ENDIF
                ENDIF
C      		IF (LINE(1:1).EQ.'C') THEN
C                  IF ((NSET.NE.1).OR.(IFLAG.EQ.0)) GOTO 7009
C                  DO 10 J=1,200-2
C                    IF (LINE(J:J+2).EQ.'FSC') GOTO 20
C10                CONTINUE
C                  GOTO 7009
C20                CONTINUE
C              WRITE(*,*)' Reading FSC Table from previous par file...'
C                  FSCT(1)=1.0
C                  DO 30 I=2,NSAM/2
C                    READ(77,7012,ERR=7013)J,FSCT(I)
C7012                FORMAT(1X,I4,24X,F7.3)
C                    IF (J.NE.I) GOTO 7013
C                    WRITE(*,7014)I,PSIZE*NSAM/REAL(I-1),FSCT(I)
C7014                FORMAT( 'IRAD, RESOL, FSC = ',I6,F7.1,F7.3)
C30                CONTINUE
C7013              CONTINUE
C                  GOTO 7009
C                ENDIF
		NANG=NANG+1
                IF (FOLD) THEN
      		  READ(LINE,7015)ILIST(NANG),PSI(NANG),THETA(NANG),
     +			PHI(NANG),SHX(NANG),SHY(NANG),ABSMAGO,FILM(NANG),
     +			DFMID1(NANG),DFMID2(NANG),ANGAST(NANG),PRESA(NANG)
7015              FORMAT(I7,5F8.2,F8.0,I6,2F9.1,F8.2,F7.2)
                  ABSMAGP=ABSMAGO
                  OCC(NANG)=100.0
                  SIG(NANG)=0.0
                ELSEIF (SLEN2(LINE).LE.128) THEN
      		  READ(LINE,70119,ERR=99)ILIST(NANG),PSI(NANG),THETA(NANG),
     +			PHI(NANG),SHX(NANG),SHY(NANG),ABSMAGP,FILM(NANG),
     +			DFMID1(NANG),DFMID2(NANG),ANGAST(NANG),OCC(NANG),
     +                  LGP,PRESA(NANG)
70119             FORMAT(I7,3F8.2,2F10.2,I8,I6,2F9.1,2F8.2,I13,
     +                   F8.2)
                  SIG(NANG)=0.0
                  ALGP(NANG)=-LGP
                  GOTO 98
                ELSE
      		  READ(LINE,7011,ERR=99)ILIST(NANG),PSI(NANG),THETA(NANG),
     +			PHI(NANG),SHX(NANG),SHY(NANG),ABSMAGP,FILM(NANG),
     +			DFMID1(NANG),DFMID2(NANG),ANGAST(NANG),OCC(NANG),
     +                  LGP,SIG(NANG),PRESA(NANG)
7011              FORMAT(I7,3F8.2,2F10.2,I8,I6,2F9.1,2F8.2,I10,
     +                   F11.2,F8.2)
                  ALGP(NANG)=-LGP
                  GOTO 98
99                CONTINUE
                  IF (NANG.EQ.1) THEN
                    WRITE(*,*) ' Error reading par file.',
     +                         ' Trying pre v9 par file format...'
                    FOLD=.TRUE.
                  ELSE
                    WRITE(*,*)
     +                ' ERROR: Something wrong in parameter file'
                    WRITE(*,*) LINE
                    STOP
                  ENDIF
98                CONTINUE
                ENDIF
      		IF(ILIST(NANG).LE.0) THEN
      		  NANG=NANG-1
      		  WRITE(*,*) ' ***WARNING*** blank line in parameter file'
      		  GO TO 7009
      		ENDIF
                IF((NANG.NE.NANG1+1).AND.
     +            (ABS(ILIST(NANG))-ABS(ILIST(NANG-1)).NE.1).AND.
     +            (NANG.LE.NNPART))
     +            WRITE(*,*) ' ***WARNING*** parameters missing for',
     +                       ' particle',ABS(ILIST(NANG))-1
		ILIST(NANG)=ILIST(NANG)*NSS
      		IF (PSI(NANG).GT.180.0) PSI(NANG)=PSI(NANG)-360.0
      		IF (THETA(NANG).GT.180.0) THETA(NANG)=THETA(NANG)-360.0
      		IF (PHI(NANG).GT.180.0) PHI(NANG)=PHI(NANG)-360.0
      		IF (PSI(NANG).LT.-180.0) PSI(NANG)=PSI(NANG)+360.0
      		IF (THETA(NANG).LT.-180.0) THETA(NANG)=THETA(NANG)+360.0
      		IF (PHI(NANG).LT.-180.0) PHI(NANG)=PHI(NANG)+360.0
      		PSI(NANG)=PSI(NANG)/180.0*PI
      		THETA(NANG)=THETA(NANG)/180.0*PI
      		PHI(NANG)=PHI(NANG)/180.0*PI
                PSX=RELMAG(NSET)*DSTEP(NSET)*10000.0/ABS(ABSMAGP)
                IF (FOLD) THEN
      		  PRESA(NANG)=COS(PRESA(NANG)/180.0*PI)*100.0
      		  SHX(NANG)=SHX(NANG)*PSX
      		  SHY(NANG)=SHY(NANG)*PSX
                ENDIF
      		IF (PRESA(NANG).GT.-100.0) THEN
      	  		AMEANPHAS=AMEANPHAS+PRESA(NANG)
      	  		NPHAS=NPHAS+1
      		ENDIF
      		PRESA(NANG)=PRESA(NANG)/100.0
      		SHX(NANG)=-SHX(NANG)/PSX/NSAM*PI*2.0
      		SHY(NANG)=-SHY(NANG)/PSX/NSAM*PI*2.0
                OCC(NANG)=OCC(NANG)/100.0
                IF (CMIN(NSET).GT.PRESA(NANG)) CMIN(NSET)=PRESA(NANG)
                IF (CMAX(NSET).LT.PRESA(NANG)) CMAX(NSET)=PRESA(NANG)
                TNSET(NSET)=TNSET(NSET)+1
                XM(NSET)=XM(NSET)+OCC(NANG)*SHX(NANG)
                YM(NSET)=YM(NSET)+OCC(NANG)*SHY(NANG)
                SX(NSET)=SX(NSET)+OCC(NANG)*SHX(NANG)**2
                SY(NSET)=SY(NSET)+OCC(NANG)*SHY(NANG)**2
                QM(NSET)=QM(NSET)+OCC(NANG)
                SIGN=SIGN+OCC(NANG)*SIG(NANG)
                INPB=INPB+1 
                IF (NANG.GT.1) THEN
                  IF (FILM(NANG).NE.FILM(NANG-1)) THEN
                    IF (INPB.GT.NPB) NPB=INPB
                    INPB=0
                  ENDIF
                ENDIF
C      		IF (IFLAG.GE.3) THEN
C      			PSI(NANG)=0.0
C      			THETA(NANG)=0.0
C      			PHI(NANG)=0.0
C      			SHX(NANG)=0.0
C      			SHY(NANG)=0.0
C      			PRESA(NANG)=0.0
C      		ENDIF
      		ANGAST(NANG)=ANGAST(NANG)/180.0*PI
      		AMAGP(NANG)=RELMAG(NSET)*DSTEP(NSET)*10000.0/
     .			(ABS(ABSMAGP)*PSIZE)
      		IF(NANG.EQ.NANG1+1) THEN
      		   IF(AMAGP(NANG).LT.0.65.OR.AMAGP(NANG).GT.1.5) THEN
      			WRITE(*,7018) AMAGP(NANG),ABSMAGP,
     .				RELMAG(NSET),PSIZE,DSTEP(NSET)
7018			FORMAT(/' ***WARNING*** particle magnification and',
     .                  ' densitometer step size'/18X,
     .                  ' incompatible with selected pixel size'/
     .                  60X,' AMAGP     = ',F9.4/
     .                  60X,' ABSMAGP   = ',I9/
     .                  60X,' RELMAG    = ',F9.4/
     .                  60X,' PSIZE     = ',F9.4/
     .                  60X,' DSTEP     = ',F9.4/)
      		   ELSE
      			WRITE(*,7019) AMAGP(NANG),ABSMAGP,
     .			RELMAG(NSET),PSIZE,DSTEP(NSET)
7019			FORMAT(/' AMAGP     = ',F9.4/
     .                          ' ABSMAGP   = ',I9/
     .                          ' RELMAG    = ',F9.4/
     .                          ' PSIZE     = ',F9.4/
     .                          ' DSTEP     = ',F9.4/)
      		   ENDIF
      		ENDIF
		IF (NANG.GT.NNPART) NANG=NANG-1
                GOTO 7009
7008		CONTINUE
		CLOSE(77)
      	ELSEIF(IFLAG.LT.0) THEN		
                CMIN(NSET)=0.0
C				! create parameter file from scratch
      		FINPAR='    none                                          '
7022      	CONTINUE
                NANG2=NANG
      		READ(*,*)NIN,ABSMAGPIN,IFILMIN,DFMID1IN,DFMID2IN,ANGASTIN,IMORE
      			NFILMS=NFILMS+1
      		NANG=NANG+NIN
                TNSET(NSET)=TNSET(NSET)+NIN
                IF (NANG.GT.NNPART) THEN
                  NIN=NIN-(NANG-NNPART)
                  NANG=NNPART
                ENDIF 
      		WRITE(*,7021)NIN,ABSMAGPIN,IFILMIN,DFMID1IN,DFMID2IN,ANGASTIN,
     .			IFLAG,IMORE
7021		FORMAT(' Parameters created for this set of particles'/
     .                 '         number of particles ...........',I8/
     .                 '         magnification .................',I10/
     .                 '         film number ...................',I8/
     .                 '         defocus 1 .....................',F10.1/
     .                 '         defocus 2 .....................',F10.1/
     .                 '         astigmatism angle..............',F10.1/
     .                 '           IFLAG........................',I8/
     .                 '           IMORE........................',I8)

      		DO 7020 J=1,NIN
      		      JN=NANG2+J
      			ILIST(JN)=JN*NSS
      			PSI(JN)=0.0
      			THETA(JN)=0.0
      			PHI(JN)=0.0
      			SHX(JN)=0.0
      			SHY(JN)=0.0
      			AMAGP(JN)=RELMAG(NSET)*DSTEP(NSET)*10000./(ABSMAGPIN*PSIZE)
      			IF(JN.EQ.1) THEN
      			   IF(AMAGP(JN).LT.0.65.OR.AMAGP(JN).GT.1.5) THEN
      				WRITE(*,7018) AMAGP(JN),ABSMAGPIN,
     .				RELMAG(NSET),PSIZE,DSTEP(NSET)
      			   ELSE
      				WRITE(*,7019) AMAGP(JN),ABSMAGPIN,
     .				RELMAG(NSET),PSIZE,DSTEP(NSET)
      			   ENDIF
      			ENDIF
      			FILM(JN)=IFILMIN
      			DFMID1(JN)=DFMID1IN
      			DFMID2(JN)=DFMID2IN
      			ANGAST(JN)=ANGASTIN/180.0*PI
      			PRESA(JN)=0.0
                        SIG(JN)=0.0
7020		CONTINUE
      		IF ((NANG.LT.NNPART).AND.(IMORE.EQ.1)) GOTO 7022
      	ENDIF
C                TNSET(NSET)=NANG-NANG1
                IF (QM(NSET).NE.0.0) THEN
                  XM(NSET)=XM(NSET)/QM(NSET)
                  YM(NSET)=YM(NSET)/QM(NSET)
                  SX(NSET)=SQRT(SX(NSET)/QM(NSET)-XM(NSET)**2)
                  SY(NSET)=SQRT(SY(NSET)/QM(NSET)-YM(NSET)**2)
                  SIGN=SIGN/QM(NSET)
                ELSEIF (TNSET(NSET).EQ.0) THEN
                  STOP ' ****ERROR**** No particles in data set!'
                ENDIF
C
		IF(NFILMS.NE.0) WRITE(*,2001) NSET,TNSET(NSET),NFILMS,NANG
		IF(NFILMS.EQ.0) WRITE(*,2002) NSET,TNSET(NSET),NANG
2001		FORMAT(' Number of images in set',I3,' =',I8,' (on',
     .                 I3,' new films)',', total particle parameters',
     .                 ' so far =',I8)
2002		FORMAT(' Number of images in set',I3,' =',I5,
     .                 ', total particle parameters so far =',I6)
                IF ((SX(NSET).LT.1.0E-6).OR.(SY(NSET).LT.1.0E-6)) THEN
                  SX(NSET)=99999.0
                  SY(NSET)=99999.0
                  WRITE(*,2004)
2004              FORMAT(/' Average X,Y shifts undetermined.',
     .                    ' X,Y ditribution function not used.')
                ELSE
		  WRITE(*,2003) CMIN(NSET)*100.0,CMAX(NSET)*100.0,
     .                        -XM(NSET)*NSAM/PI/2.0,
     .                        -YM(NSET)*NSAM/PI/2.0,
     .                        SX(NSET)*NSAM/PI/2.0,
     .                        SY(NSET)*NSAM/PI/2.0
2003		  FORMAT(/' Min, max score     =',2F8.3,/,
     .                    ' Using X,Y distribution function:',/,
     .                    ' Average X,Y shifts  =',2F8.3,/,
     .                    ' Sigma X,Y shifts    =',2F8.3)
                ENDIF
C
                IF (SIGN.EQ.0.0) THEN
                  WRITE(*,2006)
2006              FORMAT(/' Average noise sigma undetermined.'/)
                ELSE
                  WRITE(*,2005) SIGN
2005              FORMAT(/' Average noise sigma =',F8.3,/)
                ENDIF
C
C       	NANG - total number of images
C
        IF ((FOLD).AND.(ABS(THRESH(NSET)).GT.1.0)) THEN
          IF (ABS(THRESH(NSET)).EQ.90.0) THEN
            THRESH(NSET)=0.0
          ELSE
            THRESH(NSET)=COS(ABS(THRESH(NSET))/180.0*PI)*100.0
          ENDIF
        ELSEIF ((THRESH(NSET).LE.1.0).AND.
     .         (THRESH(NSET).GT.0.0)) THEN
          CALL PINC(NSET,THRESH,OCC,PRESA,NANG1,NANG)
        ENDIF
C
      		IF ((NANG.GE.IFIRST).AND.(NSETST.EQ.0)) THEN
      	  		NSETST=NSET
      	  		NNSET(NSET)=NANG-IFIRST+1
      	  		IF (NANG.GT.ILAST) NNSET(NSET)=ILAST-IFIRST+1
      		ELSEIF ((NANG1+1.GE.IFIRST).AND.(NANG.LE.ILAST)) THEN
      	  		NNSET(NSET)=NANG-NANG1
      		ELSEIF (NANG.GT.ILAST) THEN
      	  		NNSET(NSET)=ILAST-NANG1
      		ENDIF
C
        ENDIF
C
        RETURN
        END
