C*
C* Copyright 2013 Howard Hughes Medical Institute.
C* All rights reserved.
C* Use is subject to Janelia Farm Research Campus Software Copyright 1.1
C* license terms ( http://license.janelia.org/license/jfrc_copyright_1_1.html )
C*
C------------------------------------------------------------------------------
	PROGRAM FREALIGN
C------------------------------------------------------------------------------
	PARAMETER  (NSCF=50)
      	PARAMETER  (MAXSET=20,NDOC1=30,NDOC2=NDOC1+MAXSET)
CNIKO       MAXSET=100 does not work on some machines....  set back to 20
      	PARAMETER  (PI=3.1415926535897)
        PARAMETER  (HALFW=6.0)
        PARAMETER  (ITMAXA=10)
        PARAMETER  (DAMAX=360.0*PI/180.0)
      	PARAMETER  (ISYMAX=100)
      	PARAMETER  (IPMAXX=200)
        PARAMETER  (MSIZE=128)

        CHARACTER*200 SFILE,FINPAT1(MAXSET),FINPAT2(MAXSET)
        CHARACTER*200 FINPAR,F3D,FWEIGH,F3D1,F3D2,FPHA,FPOI
        CHARACTER CFORM*1,ASYMTEST*16,ASYM*3,VX*15
        CHARACTER CDATE*8,CTIME*10,CZONE*5,NCPUS*10

        INTEGER NSANG,NNSET(MAXSET),JSYM(ISYMAX),TNSET(MAXSET)
        INTEGER PMASK(5),DTVAL(8),IPAD,ISTAT,IEWALD,IRAD,IRADA
        INTEGER IREDUN,ISYM(ISYMAX),IERR,IBLOW,NNSTAT
        INTEGER OMP_GET_NUM_PROCS
        INTEGER*8 NKSUM

        INTEGER,ALLOCATABLE :: NPIX(:),NPIXT(:),NS(:),IC(:)
        INTEGER,ALLOCATABLE :: KSUM(:),ILST(:)
        INTEGER,ALLOCATABLE :: FILM(:),ILIST(:)
        INTEGER*8,ALLOCATABLE :: NKSUM1(:)

        LOGICAL FMAG,FDEF,FPART,FMATCH,ASYMSTORE,FHIST,FALL
        LOGICAL FASTIG,FBEAUT,CI(MAXSET),FCREF,FSTAT

        REAL TX(MAXSET),TY(MAXSET),DFSTD(MAXSET),DMASK(4)
        REAL RELMAG(MAXSET),CS(MAXSET),WL(MAXSET),DSTEP(MAXSET)
        REAL RREC(MAXSET),RMAX1(MAXSET),RMAX2(MAXSET),RBFAC(MAXSET)
        REAL TARGET(MAXSET),THRESH(MAXSET)
        REAL SYMOP(3,3,ISYMAX),SINCLUT(2000)
        REAL CMIN(MAXSET),CMAX(MAXSET),XM(MAXSET),YM(MAXSET)
        REAL SX(MAXSET),SY(MAXSET),QM(MAXSET)

        REAL,ALLOCATABLE :: RBIN(:),SANG(:,:)
        REAL,ALLOCATABLE :: MBUF(:),PBUF(:)
        REAL,ALLOCATABLE :: S3DF(:),BF(:)
        REAL,ALLOCATABLE :: V3DF(:),SSNR(:)
        REAL,ALLOCATABLE :: QCP(:),SIG(:)
        REAL,ALLOCATABLE :: ASUM(:)
        REAL,ALLOCATABLE :: VSUM(:)
        REAL,ALLOCATABLE :: PSUM(:)
        REAL,ALLOCATABLE :: S3DS(:),TESTPAR(:,:)
        REAL,ALLOCATABLE :: V3DS(:),DATA(:),OUTD(:)
        REAL,ALLOCATABLE :: DATD(:),CCD(:),NOIS(:)
        REAL,ALLOCATABLE :: RBINS(:),RBINN(:),RAWBINS(:)
        REAL,ALLOCATABLE :: PR(:),FSC(:),ACC(:)
        REAL,ALLOCATABLE :: QF(:),PF(:),QC(:),RBUF(:)
        REAL,ALLOCATABLE :: PSI(:),THETA(:),PHI(:),OCC(:)
        REAL,ALLOCATABLE :: AMAGP(:),PRESA(:),ANGAST(:)
        REAL,ALLOCATABLE :: DFMID1(:),DFMID2(:),SHX(:),SHY(:)
        REAL,ALLOCATABLE :: FSCT(:),ALGP(:)
        REAL,ALLOCATABLE :: REF3DV(:)

        DOUBLEPRECISION STD,VTD

        DOUBLEPRECISION,ALLOCATABLE :: VSN(:),VN(:)
        DOUBLEPRECISION,ALLOCATABLE :: VVSN(:),VVN(:)

        COMPLEX,ALLOCATABLE :: A3DF(:),A3DS(:)
        COMPLEX,ALLOCATABLE :: B3DF(:),B3DS(:)
        COMPLEX,ALLOCATABLE :: C3DF(:),C3DS(:)
        COMPLEX,ALLOCATABLE :: D3DF(:),D3DS(:)
        COMPLEX,ALLOCATABLE :: REF3DS(:)
        COMPLEX,ALLOCATABLE :: QBUQ(:),TTD1(:)
        COMPLEX,ALLOCATABLE :: CBUF(:),QBUC(:)
        COMPLEX,ALLOCATABLE :: CCBUF(:),CCS(:),PBUQ(:)
        COMPLEX,ALLOCATABLE :: DATQ(:),OUTQ(:),NOIQ(:),SPEQ(:)
        COMPLEX,ALLOCATABLE :: CTFF(:),CTFS(:)

	DATA  IPOINT/3/
	DATA  I3D1/1/
	DATA  I3D2/2/
	DATA  IPSTAT/10/
	DATA  INSTAT/9/
	DATA  INPIC/8/
	DATA  INPROJ/4/
	DATA  IOPROJ/7/
      	DATA  FALL/.TRUE./
      	DATA  FHIST/.FALSE./
      	DATA  ASYMTEST/' CDTOI0123456789'/
      	DATA  VX/'9.05 - 02.10.13'/
C       15 chars 'X.XX - XX.XX.XX' <--<--<--<--<--<--<--<--
C------------------------------------------------------------------------------
        IMP=0
#ifdef _OPENMP
        CALL GETENV('OMP_NUM_THREADS',NCPUS)
        READ(NCPUS,*,ERR=111,END=111)IMP
111     CONTINUE
        IF (IMP.LE.0) THEN
          CALL GETENV('NCPUS',NCPUS)
          READ(NCPUS,*,ERR=112,END=112)IMP
112       CONTINUE
        ENDIF
        IF (IMP.LE.0) THEN
          IMP=OMP_GET_NUM_PROCS()
        ENDIF
#endif
        IF (IMP.LE.0) IMP=1
C
	CALL CALCSINC(SINCLUT,2000)
	CALL CARD1(VX,CFORM,IFLAG,FMAG,FDEF,FASTIG,FPART,IEWALD,
     +		   FMATCH,FSTAT,FBEAUT,FCREF,IFSC,IMP,IBLOW)
        NNSTAT=0
        IF (FSTAT) NNSTAT=1
        CALL FLUSH(6)
	CALL CARD2(RI,RIC,PSIZE,WGH,XSTD,PBC,BOFF,DANGIN,IPMAX,
     +             ITMAX,ITMAXA,IPMAXX)
        CALL FLUSH(6)
	CALL CARD3(PMASK,DMASK)
        IF (DMASK(1).GE.0.0) THEN
          DMASK(1)=DMASK(1)/PSIZE
          DMASK(2)=DMASK(2)/PSIZE
          DMASK(3)=DMASK(3)/PSIZE
          DMASK(4)=DMASK(4)/PSIZE
        ENDIF
        CALL FLUSH(6)
	CALL CARD4(IFIRST,ILAST)
        NNPART=ILAST
        CALL FLUSH(6)
        CALL CARD5(ASYMTEST,ASYM,JSYM,IREDUN,SYMOP,ASYMSTORE,
     +             NSYM,NASYM,ISYM,ISYMAX)
        CALL FLUSH(6)
C-----------------------------------------------------------------------------------
      	HALFWC=HALFW
      	WGH1=SQRT(1.0-WGH**2)
      	WGH2=WGH
      	WC2=0.1
      	IRAD=1
      	AMEANPHAS=0.0
      	NPHAS=0
      	RLIM=0.0
	NANG=0			! NANG - number of angles (projections)
      	NSET=1
      	NSETST=0
      	NSS=1
      	RMM=0.0
        NPB=1
c----------------------------------------------------------------------------------
1999    CALL CARD6(FALL,NSET,MAXSET,RELMAG,DSTEP,TARGET,THRESH,CS,
     .	           AKV,WL,TX,TY)
        CALL FLUSH(6)
        IF (RELMAG(NSET).EQ.0.0.OR.(.NOT.FALL)) GOTO 1998
C
        CALL  CARD7(NSET,MAXSET,RREC,RMAX1,RMAX2,DFSTD,RBFAC)
        CALL FLUSH(6)
        CI(NSET)=FPART
C
        CALL  CARDS8AND9(NSET,MAXSET,FINPAT1,FINPAT2,INPROJ,
     .                   CFORM,ASYM,PSIZE,VX,NSAM,ICMP,RLIM,
     .                   RMM,RMAX1,RMAX2,RREC,RI,MSIZE)
#ifdef _OPENMP
        IF (NSAM/8.LT.IMP) THEN
          IMP=NSAM/8
          WRITE(*,6801) IMP
6801      FORMAT(/' Number of parallel processes too large.',
     .            ' Resetting IMP = ',I5/)
        ENDIF
        CALL OMP_SET_NUM_THREADS(IMP)
        CALL FLUSH(6)
#endif
C
C++++++++ ALLOCATE MEMORY START ++++++++++++++++++++++++++++++++++++++++++++++
C
        IF (NSET.EQ.1) THEN
C
        NN1=NSAM
C
        ALLOCATE(NPIX(NN1/2+1),NPIXT(NN1/2+1),NS(NN1),
     +           FILM(NNPART+1),ILIST(NNPART+1),STAT=IERR)
        IF (IERR.NE.0)
     +    STOP ' ERROR: Memory allocation failed for INTEGER arrays'
C
        ALLOCATE(RBIN(NN1*2),RBUF(NN1),BF(17*NN1*NN1),
     +           TESTPAR(6,IPMAXX+1),SIG(NNPART+1),
     +           DATA(NN1*NN1),OUTD(2*NN1*NN1),ALGP(NNPART+1),
     +           DATD(NN1*NN1),CCD(NN1*NN1),NOIS(NN1*NN1),
     +           RBINS(NN1*2),RBINN(NN1*2),RAWBINS(NN1*2),
     +           PSI(NNPART+1),THETA(NNPART+1),PHI(NNPART+1),
     +           AMAGP(NNPART+1),PRESA(NNPART+1),ANGAST(NNPART+1),
     +           DFMID1(NNPART+1),DFMID2(NNPART+1),OCC(NNPART+1),
     +           SHX(NNPART+1),SHY(NNPART+1),FSCT(NN1/2),STAT=IERR)
        IF (IERR.NE.0) THEN
          WRITE(*,*) ' ERROR: Memory allocation failed for REAL arrays'
          STOP ' Try setting FSTAT=F'
        ENDIF
C
        NNBIG=NN1*IBLOW
        ALLOCATE(C3DF(NNBIG/2*NNBIG*NNBIG),C3DS(NNBIG*NNBIG),
     +           CBUF(NN1/2+1),CCBUF(NN1/2*NN1),CCS(NN1),
     +           DATQ(NN1),OUTQ(NN1),NOIQ(NN1),SPEQ(NN1),
     +           CTFF(NN1*NN1),CTFS(2*NN1),STAT=IERR)
        IF (IERR.NE.0) THEN
          WRITE(*,*) ' ERROR: Memory allocation failed for',
     +               ' COMPLEX arrays'
          STOP ' Try setting IBLOW=1'
        ENDIF
C
        IPAD=INT(NNBIG/NSAM)
        IF (IPAD.GT.4) IPAD=4
        IF (IPAD.EQ.3) IPAD=2
C
C       determine the need for interpolation with radius IRADA
C       based on particle radius RI. To be safe, pretend that 3*RI
C       is particle diameter. If volume dimension IPAD*NSAM is 4 times
C       that size, IRADA=0 (one point interpolation), if IPAD*NSAM is
C       2 times the particle diameter, IRADA=1 (3 x 3 x 3 points 
C       interpolation), if IPAD*NSAM still smaller, than use IRADA=2
C       (5 x 5 x 5 points interpolation).
        I=INT(IPAD*NSAM/(3*RI))
        IF (I.LE.1) IRADA=2
        IF (I.GE.2) IRADA=1
        IF (I.GE.3) IRADA=0
        IF (IPAD.NE.1)
     .    WRITE (*,*) 'Padding reference volume, IPAD =',IPAD
        WRITE (*,*) 'Interpolation radius for reference ',
     .    'IRADA =',IRADA
        WRITE(*,*)
        CALL FLUSH(6)
C
        IF (NSET.EQ.1) THEN
          DO 81 I=1,NSAM/2
            FSCT(I)=0.0
81        CONTINUE
        ENDIF
C
        ENDIF
C
        CALL CARD10(NANG,IFLAG,FINPAR,NNPART,ILIST,PSI,THETA,PHI,
     +              SHX,SHY,FILM,DFMID1,DFMID2,ANGAST,OCC,PRESA,
     +              AMEANPHAS,NPHAS,NSAM,AMAGP,NSET,PSIZE,MAXSET,
     +              RELMAG,NSS,IFIRST,ILAST,NNSET,NSETST,DSTEP,TNSET,
     +              FSCT,THRESH,CMIN,CMAX,XM,YM,SX,SY,QM,NPB,ALGP,
     +              SIG)
        IF (NPB*NN1*NN1.GT.1024*1024*256) NPB=1024*1024*256/NN1/NN1
        IF (FMAG.OR.(FDEF.AND.(.NOT.FPART))) THEN
          ALLOCATE(ILST(NPB),MBUF(NPB*NN1*NN1),PBUF(NPB*NN1*NN1),
     +             QBUQ(NPB*NN1),QBUC(NPB*NN1/2*NN1),
     +             PBUQ(NPB*NN1),STAT=IERR)
          IF (IERR.NE.0)
     +    STOP ' ERROR: Memory allocation failed for BUFFER arrays'
        ELSEIF (FDEF) THEN
          ALLOCATE(ILST(1),MBUF(NN1*NN1),PBUF(NN1*NN1),
     +             QBUQ(NN1),QBUC(NN1/2*NN1),
     +             PBUQ(NN1),STAT=IERR)
          IF (IERR.NE.0)
     +    STOP ' ERROR: Memory allocation failed for BUFFER arrays'
        ELSEIF (XSTD.LT.0.0) THEN
          ALLOCATE(ILST(1),MBUF(NN1*NN1),STAT=IERR)
          IF (IERR.NE.0)
     +    STOP ' ERROR: Memory allocation failed for BUFFER arrays'
        ENDIF
        CALL FLUSH(6)
        IF (DMASK(1).LT.0.0) THEN
          DMASK(1)=NSAM/2
          DMASK(2)=NSAM/2
          DMASK(3)=NSAM/2
          DMASK(4)=RI
        ENDIF
	CALL CARDS11AND12(NDOC1,NDOC2,NSET,CDATE,CTIME,CZONE,DTVAL,VX,
     .		    CFORM,IFLAG,FMAG,FDEF,FASTIG,FPART,IEWALD,FMATCH,
     .		    FSTAT,FBEAUT,FCREF,RI,RIC,PSIZE,WGH,XSTD,PBC,BOFF,
     .              ASYM,NSYM,SYMOP,IPMAX,ITMAX,DANGIN,IFIRST,ILAST,NSS,
     .	            MAXSET,RELMAG,DSTEP,TARGET,THRESH,CS,AKV,RREC,
     .              RMAX1,RMAX2,RBFAC,FINPAT1,FINPAT2,FINPAR,ISYMAX,
     .              TX,TY,IFSC,DFSTD,IBLOW,PMASK,DMASK)
        DMASK(1)=DMASK(1)+1.0
        DMASK(2)=DMASK(2)+1.0
        DMASK(3)=DMASK(3)+1.0
        CALL FLUSH(6)

      	GOTO 1999
1998	CONTINUE
C   End of input data cards - only map files are read in after this
C
        IF (FALL) THEN
          ALLOCATE(KSUM(NN1/2*NN1*NN1*NNSTAT+1),IC(NN1),STAT=IERR)
          IF (IERR.NE.0)
     +      STOP ' ERROR: Memory allocation failed for INTEGER arrays'
        ENDIF
C
        IF (FALL) THEN
          ALLOCATE(S3DF(NN1/2*NN1*NN1),
     +             S3DS(NN1*NN1),SSNR(NN1/2*NN1*NN1*NNSTAT+1),
     +             QCP(NN1/2*NN1*NN1*NNSTAT+1),NKSUM1(IMP),
     +             ASUM(NN1/2*NN1*NN1*NNSTAT+1),TTD1(IMP),
     +             VSUM(NN1/2*NN1*NN1*NNSTAT+1),
     +             PSUM(NN1/2*NN1*NN1*NNSTAT+1),
     +             REF3DV(NN1*NN1*NN1*NNSTAT+2),STAT=IERR)
          IF (IERR.NE.0) THEN
            WRITE(*,*) ' ERROR: Memory allocation failed',
     +                 ' for REAL arrays'
            STOP ' Try setting FSTAT=F'
          ENDIF
          IF (IFSC.EQ.0) THEN
            ALLOCATE(V3DF(NN1/2*NN1*NN1),V3DS(NN1*NN1),
     +           STAT=IERR)
            IF (IERR.NE.0) THEN
              WRITE(*,*) ' ERROR: Memory allocation failed',
     +                 ' for REAL arrays'
              STOP ' Try setting IFSC=1'
            ENDIF
          ENDIF
          IF ((IFSC.EQ.0).OR.(NNSTAT.NE.0)) THEN
            ALLOCATE(PR(NN1/2+1),FSC(NN1/2+1),ACC(NN1/2+1),
     +           QF(NN1/2+1),PF(NN1/2+1),QC(NN1/2+1),
     +           STAT=IERR)
            IF (IERR.NE.0) THEN
              WRITE(*,*) ' ERROR: Memory allocation failed',
     +                 ' for REAL arrays'
              STOP ' Try setting IFSC=1 or NNSTAT=0'
            ENDIF
          ENDIF
        ENDIF
C
        IF (FALL) THEN
          ALLOCATE(VSN(NN1),VN(NN1),VVSN(NN1),VVN(NN1),STAT=IERR)
          IF (IERR.NE.0)
     +    STOP ' ERROR: Memory allocation failed for DPRECISION arrays'
        ENDIF
C
        IF (FALL) THEN
          ALLOCATE(A3DF(NN1/2*NN1*NN1),A3DS(NN1*NN1),
     +             REF3DS(NN1*NN1*NNSTAT+1),STAT=IERR)
          IF (IERR.NE.0)
     +    STOP ' ERROR: Memory allocation failed for COMPLEX arrays'
          IF (IFSC.EQ.0) THEN
            ALLOCATE(B3DF(NN1/2*NN1*NN1),B3DS(NN1*NN1),
     +               D3DF(NN1/2*NN1*NN1),D3DS(NN1*NN1),
     +               STAT=IERR)
            IF (IERR.NE.0) THEN
              WRITE(*,*) ' ERROR: Memory allocation failed for',
     +                   ' COMPLEX arrays'
              STOP ' Try setting IFSC=1'
            ENDIF
          ENDIF
        ELSEIF ((IPAD.NE.1).OR.(XSTD.NE.0.0)) THEN
            ALLOCATE(B3DF(NN1/2*NN1*NN1),B3DS(NN1*NN1),
     +               STAT=IERR)
            IF (IERR.NE.0) THEN
              WRITE(*,*) ' ERROR: Memory allocation failed for',
     +                   ' COMPLEX arrays'
              STOP ' Try setting IBLOW=1'
            ENDIF
        ENDIF
C
C----------------------------------------------------------------------------------
C++++++++ ALLOCATE MEMORY END ++++++++++++++++++++++++++++++++++++++++++++++++
C
C        IF ((FSCT(1).EQ.0.0).AND.(IFLAG.NE.0))
C     .                 WRITE(*,*)' *** No FSC table - refinement ',
C     .                           ' slightly less accurate'
      	IFLAG=IABS(IFLAG)
      	IF (NANG.LT.ILAST) ILAST=NANG
      	NSET=NSET-1
      	WRITE(*,*) 'End of input datasets, number of datasets =',NSET
      	IF (BOFF.EQ.0.0) THEN
          IF (NPHAS.NE.0) AMEANPHAS=AMEANPHAS/NPHAS
      	  BOFF=AMEANPHAS
      	  WRITE(*,6800)BOFF
6800	  FORMAT(' Average score used ',F8.4)
      	ENDIF
        CALL FLUSH(6)
c----------------------------------------------------------------------------------
        IF (IFLAG.GE.3) THEN
	  CALL SEARCHANG(RMM,RI,DANGIN,NSANG,IQUADMAX,ASYM,NASYM,
     .	  SANG,NDOC1,NSET,ASYMSTORE,PMASK,.FALSE.)
          ALLOCATE(SANG(3,NSANG),STAT=IERR)
          IF (IERR.NE.0)
     +      STOP ' ERROR: Memory allocation failed for SANG array'
	  CALL SEARCHANG(RMM,RI,DANGIN,NSANG,IQUADMAX,ASYM,NASYM,
     .	  SANG,NDOC1,NSET,ASYMSTORE,PMASK,.TRUE.)
	ENDIF
C  end of loop for search angle generation.
c----------------------------------------------------------------------------------
      	RII=RI+HALFW/2.0
      	RIH=RI-HALFW/2.0
      	IF (RIH.LT.0.0) RIH=0.0
      	RI2=RIH**2
      	RI3=RII**2
      	RI4=RI**2

      	CALL DATE_AND_TIME(CDATE,CTIME,CZONE,DTVAL)
      	IRAN=-DTVAL(8)

      	JC=NSAM/2+1
      	NSAMH=NSAM/2
      	STD=0.0
      	VTD=0.0

        IF (FALL) THEN
      	  DO 103 K=1,NSAM
      	    DO 103 J=1,NSAM
      	      IS=J+NSAM*(K-1)
      	      A3DS(IS)=CMPLX(0.0,0.0)
      	      S3DS(IS)=0.0
      	      DO 103 I=1,NSAM/2
      	        ID=I+NSAMH*((J-1)+NSAM*(K-1))
      	        A3DF(ID)=CMPLX(0.0,0.0)
      	        S3DF(ID)=0.0
103	  CONTINUE
          IF (IFSC.EQ.0) THEN
      	    DO 102 K=1,NSAM
      	      DO 102 J=1,NSAM
      	        IS=J+NSAM*(K-1)
      	        D3DS(IS)=CMPLX(0.0,0.0)
      	        V3DS(IS)=0.0
      	        DO 102 I=1,NSAM/2
      	          ID=I+NSAMH*((J-1)+NSAM*(K-1))
      	          D3DF(ID)=CMPLX(0.0,0.0)
      	          V3DF(ID)=0.0
102	    CONTINUE
          ENDIF
          IF (NNSTAT.NE.0) THEN
      	    DO 101 K=1,NSAM
      	      DO 101 J=1,NSAM
      	        DO 101 I=1,NSAM/2
      	          ID=I+NSAMH*((J-1)+NSAM*(K-1))
      	          KSUM(ID)=0
      	          PSUM(ID)=0.0
      	          VSUM(ID)=0.0
      	          ASUM(ID)=0.0
      	          QCP(ID)=0.0
      	          SSNR(ID)=0.0
101	    CONTINUE
          ENDIF
          DO 80 K=1,NSAM/2
            VSN(K)=0.0D0
            VN(K)=0.0D0
            VVSN(K)=0.0D0
            VVN(K)=0.0D0
            IC(K)=0
80        CONTINUE
        ENDIF
c----------------------------------------------------------------------------------
	CALL CARDS13AND14(F3D,FWEIGH,FMATCH,FDEF,FMAG,INPIC,
     .              INSTAT,IFLAG,ISTAT,NSAM,NSAMH,NN1,JC,
     .              PSIZE,UTD,STDD,B3DF,
     .              B3DF,B3DS,C3DF,C3DF,C3DS,CFORM,ASYM,VX,
     .              RI,HALFW,XSTD,IPAD,IEWALD,FALL)
        CALL FLUSH(6)
c----------------------------------------------------------------------------------
      	NKSUM=0
      	NSTART=IFIRST
      	ISWITCH=0
      	IF (IFSC.EQ.2) ISWITCH=1
      	FFLAG=0
      	PSIS=0.0
      	THETAS=0.0
      	PHIS=0.0
      	DSHXS=0.0
      	DSHYS=0.0
      	DFMID1S=0.0
      	DFMID2S=0.0
      	ANGASTS=0.0
      	OCCS=0.0
      	ALGPS=0.0
        DALGPS=0.0
      	DPRESS=0.0
      	ABSMAGS=0.0
      	PRESS=0.0
      	NSET=NSETST
        IEXCL=0
      	IBUF=0
      	IALL=0
      	PALL=0.0
      	OALL=0.0
      	CCAVE=0.0
      	ICOUNT=0
      	ICCOUNT=0
      	DO 253 I=1,NSAM*2
      	  RBINS(I)=0.0
      	  RBINN(I)=0.0
      	  RAWBINS(I)=0.0
253	CONTINUE
c----------------------------------------------------------------------------------
	CALL  CARDS15TO18(F3D,FWEIGH,F3D1,F3D2,FPHA,FPOI,NDOC1)
        CALL FLUSH(6)
c----------------------------------------------------------------------------------
C	MAIN LOOP OVER PARTICLES.....

      	DO 11 K=NSTART,ILAST
	CALL LMAIN(K,FDEF,FMAG,INPROJ,CFORM,DATA,RREC,
     +      NSAM,DATA,SHX,SHY,CS,RAWBINS,WL,WGH1,WGH2,
     +      DFMID1,DFMID2,ANGAST,OCC,OUTD,OUTD,AMAGP,RIH,HALFW,
     +      HALFWC,RI2,RI3,RI4,DATD,DATD,B3DF,PHI,THETA,PSI,XSTD,
     +      IFLAG,IRADA,C3DF,C3DS,RBINS,RBINN,NSET,NOIS,NOIS,PRESA,
     +      SANG,NSANG,CCD,CCD,IQUADMAX,NDOC1,NDOC2,PMASK,RBFAC,
     +      RMAX1,RMAX2,IRAN,PSIZE,DSTEP,FILM,NN1,NNPART,MAXSET,
     +      FHIST,ILIST,NPB,ITMAX,DAMAX,ASYMSTORE,TARGET,ICCOUNT,
     +      ISWITCH,IPAD,PALL,IALL,IRAD,RI,A3DF,A3DS,S3DF,S3DS,
     +      STD,D3DF,D3DS,ILST,V3DF,V3DS,VTD,PBC,BOFF,ASUM,
     +      VSUM,PSUM,KSUM,THRESH,NSAMH,JC,FFLAG,CCAVE,ICMP,IFIRST,
     +      IOPROJ,IEWALD,NSCF,SFILE,NANG,WGH,PSIS,THETAS,
     +      PHIS,DSHXS,DSHYS,PRESS,IEXCL,IBUF,ICOUNT,FMATCH,
     +      DFMID1S,DFMID2S,ANGASTS,OCCS,ALGPS,DPRESS,ABSMAGS,
     +      NSTART,FINPAT1,FINPAT2,ASYM,VX,ILAST,NNSET,IANG,CDATE,
     +      CTIME,CZONE,DTVAL,FASTIG,SINCLUT,MBUF,PBUF,CTFF,CTFS,
     +      RBIN,CCBUF,CCS,DATQ,OUTQ,NOIQ,SPEQ,PBUQ,QBUC,QBUQ,ISTAT,
     +      TNSET,FALL,IC,VSN,VN,VVSN,VVN,CI,BF,NS,NA,FSCT,
     +      TX,TY,TESTPAR,IPMAX,NSYM,ISYM,JSYM,SYMOP,NNSTAT,
     +      NKSUM,XM,YM,SX,SY,IFSC,IMP,OALL,DFSTD,ALGP,DALGPS,DMASK,
     +      NKSUM1,TTD1,SIG)

11	CONTINUE

C END MAIN LOOP

	CALL ICLOSE(INPROJ)
        IF (FMATCH) CALL ICLOSE(IOPROJ)

      	WRITE(*,6500)NSET,IEXCL
6500          FORMAT(/' PARTICLES BELOW THRESHOLD (NOT INCLUDED)',
     +               ' IN SET ',I3,': ',I10)
        CALL FLUSH(6)
C
        IF (OCCS.NE.0.0) THEN
          PRESS=PRESS/OCCS
          DPRESS=DPRESS/OCCS
          ALGPS=ALGPS/OCCS
          DALGPS=DALGPS/OCCS
        ENDIF
C
      	IF (ICOUNT.NE.0.0) THEN
      	  WRITE(NDOC2+NSET,7012)SQRT(PSIS/ICOUNT),SQRT(THETAS/ICOUNT),
     +		SQRT(PHIS/ICOUNT),SQRT(DSHXS/ICOUNT),SQRT(DSHYS/ICOUNT),
     +		NINT(SQRT(ABSMAGS/ICOUNT)),SQRT(DFMID1S/ICOUNT),
     +		SQRT(DFMID2S/ICOUNT),SQRT(ANGASTS/ICOUNT),0.0,
     +          -NINT(DALGPS),DPRESS
	    CALL FLUSH(NDOC2+NSET)
7012      FORMAT('C',6X,3F8.2,2F10.2,I8,6X,2F9.1,2F8.2,I13,
     +           2F8.2)
      	ENDIF
C
        IF (OALL.NE.0.0) PALL=PALL/OALL*100.0
        IF (IALL.NE.0) OALL=OALL/IALL*100.0
        WRITE(*,16401)IALL,PALL,OALL
16401   FORMAT(I10,' PARTICLES FOR OVERALL SCORE CALCULATION',
     +        /6X,' SCORE (between resolution limits) =',F11.6,
     +        /6X,' AVERAGE OCCUPANCY                 =',F11.6)
        CALL FLUSH(6)
        WRITE(NDOC1+1,16402)IALL,PALL,OALL
16402   FORMAT('C  Total particles included, overall score, ',
     +         'average occupancy',I12,2F11.6)
C
      	IF (ICCOUNT.NE.0) THEN
      	  CCAVE=CCAVE/ICCOUNT
      	  WRITE (*,6403)ICCOUNT,CCAVE
6403	  FORMAT(/I10,' PARTICLES REFINED, AVERAGE CC',F12.8/)
          CALL FLUSH(6)
      	  WRITE(NDOC1+1,6404)ICCOUNT,CCAVE
6404	  FORMAT('C  No. of particles refined, ave. CC',I10,F12.8)
      	ENDIF

      	IF(.NOT.FALL) STOP ' Normal termination, no output data-files'
C
C      	STD=STD/NSAM/NSAM/NSAM		! invalid for low resolution
      	STD=STD/NKSUM
      	STD=STD*WC2
C      	VTD=VTD/NSAM/NSAM/NSAM		! invalid for low resolution
      	VTD=VTD/NKSUM
      	VTD=VTD*WC2
C
C S3DF,S3DS : stats file 1
C V3DF,V3DS : stats file 2
C A3DF,A3DS : reconstruction 1
C D3DF,D3DS : reconstruction 2
C ASUM,---- : sum of amplitudes
C VSUM,---- : sum of amplitudes**2
C PSUM,---- : sum of phase residuals
C KSUM,---- : number of terms contributing to voxel
C
	CALL STORESHIFT(STD,VTD,JC,NSAM,NSAMH,IREDUN,NN1,
     +                  QCP,ASUM,KSUM,PSUM,VSUM,SSNR,A3DF,B3DF,
     +                  C3DF,D3DF,S3DF,V3DF,REF3DV,A3DS,B3DS,
     +                  C3DS,D3DS,S3DS,V3DS,REF3DS,IPAD,NNSTAT,
     +                  IFSC)
C	TEST RESOLUTION - ISTP is step size in pixels for resolution statistics
      	ISTP=1
        IF (IFSC.EQ.0) THEN
!$OMP PARALLEL SECTIONS
!$OMP SECTION
          CALL RLFT3(B3DF,B3DS,NSAM,NSAM,NSAM,-1)
          CALL CORRECT3D(NSAM,SINCLUT,B3DF,IRAD) 
          CALL MASK3D(NSAM,B3DF,RI,RIC,HALFW) 
!$OMP SECTION
          CALL RLFT3(C3DF,C3DS,NSAM,NSAM,NSAM,-1)
          CALL CORRECT3D(NSAM,SINCLUT,C3DF,IRAD)
          CALL MASK3D(NSAM,C3DF,RI,RIC,HALFW)
!$OMP END PARALLEL SECTIONS
          CALL OPMAPS2(F3D1,F3D2,I3D1,I3D2,
     .               JC,NSAM,NSAMH,PSIZE,B3DF,C3DF,
     .               CFORM,ASYM,VX,RBUF)
!$OMP PARALLEL SECTIONS
!$OMP SECTION
          CALL RLFT3(B3DF,B3DS,NSAM,NSAM,NSAM,1)
!$OMP SECTION
          CALL RLFT3(C3DF,C3DS,NSAM,NSAM,NSAM,1)
!$OMP END PARALLEL SECTIONS

C	PSUM contains average phase errors - not as informative as SSNR
C	-> PSUM replaced by SSNR. Change back if PSUM needed. Output of
C	shell-averaged values is still PF.
      	  CALL SHELTEST(NSAM,ISTP,B3DF,B3DS,C3DF,C3DS,ASUM,SSNR,KSUM,
     +		      QCP,NSTP,PR,FSC,ACC,QF,QC,PF,NS,NPIX,NPIXT,RBUF,
     +		      CBUF,IREDUN,NNSTAT)
	  CALL OPRESSTATHALF(NDOC1,VSN,VN,RAWBINS,PF,PR,ISTP,NSTP,NSAM,
     .                     RLIM,PSIZE,FSC,QF,QC,ACC,NPIX,NPIXT,CDATE,
     .                     CTIME,CZONE,DTVAL,VX,NN1,IC,VVSN,VVN,IALL,
     .                     NA)
        ELSE
          WRITE(*,9996)IFSC
9996      FORMAT(/' *** IFSC set to',I2,' to save memory:',
     +            ' FSC statistics not done ***'/)
          CALL FLUSH(6)
        ENDIF

	CALL SHIFTVOL(NSAM,STD,VTD,JC,RLIM,NSAMH,NN1,IREDUN,A3DS,
     +        D3DS,A3DF,D3DF,S3DS,V3DS,S3DF,V3DF,ASUM,QCP,NNSTAT,
     +        IFSC)
        IF ((FCREF).AND.(IFSC.EQ.0)) THEN
!$OMP PARALLEL SECTIONS
!$OMP SECTION
          CALL APPLYCREF(NSAM,A3DF,A3DS,FSC)
!$OMP SECTION
          CALL APPLYCREF(NSAM,D3DF,D3DS,FSC) 
!$OMP END PARALLEL SECTIONS
        ENDIF
!$OMP PARALLEL SECTIONS
!$OMP SECTION
        CALL RLFT3(A3DF,A3DS,NSAM,NSAM,NSAM,-1)
        CALL CORRECT3D(NSAM,SINCLUT,A3DF,IRAD)
!$OMP SECTION
        IF (IFSC.EQ.0) CALL RLFT3(D3DF,D3DS,NSAM,NSAM,NSAM,-1)
        IF (IFSC.EQ.0) CALL CORRECT3D(NSAM,SINCLUT,D3DF,IRAD)
!$OMP END PARALLEL SECTIONS

        IF(FBEAUT) CALL BEAUTIFY(NSAM,NSYM,SYMOP,JSYM,A3DF,B3DF,RI,
     +                           HALFW,IMP)
        CALL MASK3D(NSAM,A3DF,RI,RIC,HALFW)

	CALL OPMAPS(FPOI,FPHA,INSTAT,IPSTAT,
     .              IPOINT,INPIC,PSUM,NDOC1,NDOC2,
     .              NSET,NN1,JC,NSAM,NSAMH,PSIZE,A3DF,D3DF,S3DF,
     .              S3DS,CFORM,ASYM,VX,RBUF,NNSTAT,IFSC)

        IF (NNSTAT.NE.0) THEN

C	NOW CALCULATE BRIEF STATISTICS BETWEEN STORED REFERENCE TRANSFORM 
C         REF3D AND THE COMPLETE MERGED NEW DATA A3DF VERSUS RESOLUTION
      	CALL RLFT3(A3DF,A3DS,NSAM,NSAM,NSAM,1)
      	CALL SHELTEST(NSAM,ISTP,A3DF,A3DS,REF3DV,REF3DS,ASUM,SSNR,KSUM,
     +		      QCP,NSTP,PR,FSC,ACC,QF,QC,PF,NS,NPIX,NPIXT,RBUF,
     +                CBUF,IREDUN,NNSTAT)
	CALL OPRESSTATMAPS(NSTP,ISTP,NSAM,RLIM,PSIZE,PR,
     +			FSC,ACC,NPIX,NPIXT,NN1)

        ELSE
          WRITE(*,9997)
9997      FORMAT(/' *** FSTAT set to F to save memory:',
     +            ' some statistics not done ***'/)
          CALL FLUSH(6)
        ENDIF

      	CALL DATE_AND_TIME(CDATE,CTIME,CZONE,DTVAL)
      	WRITE(*,9998) CDATE(7:8),CDATE(5:6),CDATE(1:4),
     .		CTIME(1:2),CTIME(3:4),CTIME(5:8)
9998	FORMAT(' Final date/time ',A2,'-',A2,'-',A4,'/',A2,':',A2,':',A4)
        CALL FLUSH(6)

      	STOP ' NORMAL TERMINATION OF FREALIGN'
	END
